#!/usr/bin/env node
import { I as r, S as a } from "./types-a1ee6691.js";
import { log as n, _get as I, getConfigFileCommonOptions as h, initHandlerCommon as _, _set as b, readConfigFile as k, _curry as A, createSubcommand as D, createMainCommand as w } from "@done-coding/cli-utils";
import F from "node:path";
import m from "node:fs";
const G = ({
  sourceJson: e,
  targetKey: o,
  keyConfig: t
}) => {
  let s;
  typeof t == "string" ? s = {
    type: r.FIXED,
    value: t
  } : s = t;
  const { type: l = r.READ } = s;
  switch (l) {
    case r.REG: {
      const { sourceKey: i, pattern: d, replaceValue: p, flags: g } = s, E = new RegExp(d, g ?? void 0), c = I(e, i);
      return typeof c == "string" ? c.replace(E, p) : (n.warn(
        `${c}不是字符串类型，无法使用正则表达式进行替换，此处将直接返回原值`
      ), c);
    }
    case r.FIXED: {
      const { value: i } = s;
      return i;
    }
    case r.READ:
      return I(e, o);
    default: {
      n.warn(`未知的配置类型${l}`);
      return;
    }
  }
}, M = {
  sourceFilePath: "./package.json",
  keyConfigMap: {
    name: {
      type: r.READ
    },
    version: {
      type: r.READ
    },
    description: {
      type: r.READ
    }
  },
  injectFilePath: "./src/injectInfo.json"
}, N = M, R = {
  name: "@done-coding/cli-inject",
  version: "0.5.3-alpha.0",
  description: "信息(JSON)注入命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "inject"
  }
}, {
  cliConfig: { namespaceDir: x, moduleName: H }
} = R, L = `./${x}/${H}`, T = `${L}.json`, J = () => h({
  configPathDefault: T
}), U = async (e) => _(N, e, {
  onFileGenerated: () => {
    n.info("文件生成成功");
  }
}), V = () => ({
  ...h({
    configPathDefault: T
  })
}), W = async ({
  rootDir: e = process.cwd(),
  config: o = N,
  keyConfigMap: t = {}
} = {}) => {
  const {
    sourceFilePath: s,
    keyConfigMap: l,
    injectFilePath: i
  } = o, d = {
    ...l,
    ...t
  };
  if (!s.endsWith(".json"))
    return n.error("源文件必须是json"), process.exit(1);
  if (!i.endsWith(".json"))
    return n.error("注入文件必须是json"), process.exit(1);
  const p = F.resolve(e, s), g = m.readFileSync(p, "utf-8"), E = JSON.parse(g), c = Object.entries(d).reduce(
    (f, [C, $]) => {
      const P = G({ sourceJson: E, targetKey: C, keyConfig: $ });
      return b(f, C, P), f;
    },
    {}
  ), u = F.resolve(e, i), y = JSON.stringify(c, null, 2);
  if (m.existsSync(u)) {
    const f = m.readFileSync(u, "utf-8");
    if (y === f)
      return n.skip("注入文件已存在且内容相同，无需重复注入"), c;
    n.stage("文件内容变化,开始覆盖注入文件");
  } else
    n.stage("开始注入文件");
  m.writeFileSync(u, y), n.success(`文件注入成功: ${u}`), n.info(y);
}, X = async (e) => {
  const o = await k(e);
  if (!o)
    return n.error("配置文件为空"), process.exit(1);
  const { rootDir: t } = e;
  await W({ rootDir: t, config: o });
}, v = async (e, o) => e === a.INIT ? U(o) : e === a.GENERATE ? X(o) : (n.error(`无效的命令: ${e}`), process.exit(1)), {
  version: K,
  description: q,
  cliConfig: { moduleName: j }
} = R, z = {
  command: a.INIT,
  describe: "初始化提取配置文件",
  options: J(),
  handler: A(v)(
    a.INIT
  )
}, B = {
  command: a.GENERATE,
  describe: "提取信息",
  options: V(),
  handler: A(v)(
    a.GENERATE
  )
}, O = {
  describe: q,
  version: K,
  subcommands: [z, B].map(
    D
  ),
  demandCommandCount: 1
}, S = (e = !1) => {
  const o = e ? j : void 0, t = `$0${e ? ` ${j}` : ""} <command> [options]`;
  return { command: o, usage: t };
}, ne = async () => w({
  ...O,
  ...S()
}), oe = () => D({
  ...O,
  ...S(!0)
});
export {
  oe as a,
  ne as c,
  W as g,
  v as h,
  G as k
};
